uses
  crt;
type
  zeiger=^daten;
  namen=array[1..9] of string[15];
  daten=record
          treffer:byte;
          name:string;
          verweis:zeiger;
        end;
const
  nl:namen=('Bill Clinton','Prinz Eisenherz','Lanzelot','Kunibert','Dagobert','Vlado','Herr Schimpf','Monica Lewinski','Mog');
{  maxritter=8; {Anzahl der Ritter}
{  warte=3000; {Verzgerung in Millisekunden}
{  guete=70;   {Trefferwarscheinlichkeit von 1% bis guete%}
var
  erster_ritter,ritter:zeiger;
  runde:longint;
  guete,maxritter:byte;
  warte:word;
  ch:char;

procedure ausgeben(anfang:boolean);
var
  i,anzahl:shortint;
  lauf:zeiger;
begin
  textbackground(black); window(1,2,80,20); clrscr;
  writeln(^j,'   Runde ',runde,', die Situation: ');
  anzahl:=(-2);
  lauf:=erster_ritter;
  repeat                        {Anzahl der Ritter feststellen}
    inc(anzahl);
    lauf:=lauf^.verweis;
  until lauf=erster_ritter;
  gotoxy(9,5);
  if lauf = ritter then textcolor(white) else textcolor(lightgray);
  write('1. Ritter: ',lauf^.name:15,'(',lauf^.treffer,')  ',chr(26),' ');
  lauf:=lauf^.verweis;
  if lauf = ritter then textcolor(white) else textcolor(lightgray);
  writeln(lauf^.name,'(',lauf^.treffer,')');
  lauf:=lauf^.verweis;
  for i:= 1 to ((anzahl+1) div 2) do
    begin
      gotoxy(49,wherey);
      writeln(chr(25));
      gotoxy(44,wherey);
      if lauf = ritter then textcolor(white) else textcolor(lightgray);
      writeln(lauf^.name,'(',lauf^.treffer,')');
      lauf:=lauf^.verweis;
    end;
  gotoxy(39,(wherey-1));
  write(chr(27),'');
  for i:= 1 to (anzahl div 2) do
    begin
      gotoxy(20,wherey);
      if lauf = ritter then textcolor(white) else textcolor(lightgray);
      write(lauf^.name:15,'(',lauf^.treffer,')');
      gotoxy(32,(wherey-1));
      write(chr(24));
      gotoxy(wherex,(wherey-1));
      lauf:=lauf^.verweis;
    end;
  window(3,21,77,24);
  textbackground(blue); textcolor(lightgray);
  if anfang then clrscr;
  gotoxy(1,4);
end;

procedure init;
var
  vorgaenger:zeiger;
  i:byte;
  nummer:string;
begin
  runde:=1;
  textbackground(black);clrscr;
  gotoxy(20,1);write('Ritterspiele!'); gotoxy(50,wherey);writeln('Version 0.01, Vlado Plaga 1998');
  write('Wieviele Ritter sollen mitspielen (empfohlen: 8)? ');
  readln(maxritter);
  write('Wie gut sollen die Ritter hchstens sein (Trefferquote in %)? ');
  readln(guete);
  write('Wie lange sollen die Kmpfe dauern (in Millisekunden, empfohlen 3000)? ');
  readln(warte);
  if warte<20 then warte:=20;
  randomize;
  for i:=1 to maxritter do
    begin
      str(i,nummer);
      new(ritter);
      ritter^.treffer:=(random(guete)+1);
      if i > 9 then ritter^.name:=('Ritter '+nummer) else ritter^.name:=(nl[i]);
      if i=1 then erster_ritter:=ritter else vorgaenger^.verweis:=ritter;
      vorgaenger:=ritter;
      ritter^.verweis:=erster_ritter;
    end;
  ritter:=erster_ritter;
end;             {von procedure init}

procedure stoss;
var
  nachfolger:zeiger;
  i:word;
begin
  nachfolger:=ritter^.verweis;
  write(ritter^.name, ' will ', nachfolger^.name, ' aus dem Sattel heben');
  for i:=1 to warte do    {Verzoegerungsschleife...}
    begin
      delay(1);
      if i mod (warte div 10) = 0 then write('.');
    end;
  if ritter^.treffer > random(100) then     {Treffer oder Daneben?}
    begin
      textcolor(red+blink);
      write('Getroffen!');
      delay(warte div 2);
      textcolor(lightgray);
      gotoxy((wherex-length('getroffen!')),wherey);
      writeln('Getroffen!');
      writeln('Tsch ',nachfolger^.name,'...');
      delay(warte div 4);
      writeln(ritter^.name,'s Trefferquote hat sich um ',(nachfolger^.treffer div 2),' verbessert!');
      delay(warte div 4);
      ritter^.treffer:=(ritter^.treffer+nachfolger^.treffer div 2);
      ritter^.verweis:=nachfolger^.verweis;
      if nachfolger=erster_ritter then erster_ritter:=ritter;
    end
   else
     begin
       writeln('daneben!');
       writeln(ritter^.name,'s Trefferquote hat sich um ',(ritter^.treffer div 4),' verschlechtert!');
       delay(warte div 4);
       ritter^.treffer:=(ritter^.treffer-ritter^.treffer div 4);
     end;
end;    {von procedure stoss}

procedure hinzufuegen;
var
  aktuell:zeiger;
begin
  aktuell:=ritter;
  new(ritter);
  ritter^.verweis:=aktuell^.verweis;
  aktuell^.verweis:=ritter;
  write('Ritter hinzufgen: Wie soll der Neue heissen? ');
  readln(ritter^.name);
  write('Wie gut ist ',ritter^.name,'(Trefferquote)? ');
  readln(ritter^.treffer);
  writeln('Here comes a new challenger...');
end;

begin
  init;
  ausgeben(true);
  writeln('Taste drcken, um zu starten...         ...Esc zum Beenden!');
  ch:=readkey;
  while ((ritter<>ritter^.verweis)and (ord(ch)<>27)) do
    begin
      ausgeben(false);
      stoss;
      if keypressed then
        begin
          ch:=readkey;
          if ord(ch)<>27 then hinzufuegen;
        end
       else ritter:=ritter^.verweis;
      if ritter=erster_ritter then inc(runde);
    end;
  ausgeben(false);
  gotoxy(20,10);
  write(ritter^.name,' hat gewonnen!');
  ch:=readkey;
end.